//Hector Leonel Gutierrez - 20540
//Manufactura digital
//Proyecto 2 (rocola)


//Definimos la frecuencia de las notas musicales en las 8 octavas.
#define NOTE_B0  31
#define NOTE_C1  33
#define NOTE_CS1 35
#define NOTE_D1  37
#define NOTE_DS1 39
#define NOTE_E1  41
#define NOTE_F1  44
#define NOTE_FS1 46
#define NOTE_G1  49
#define NOTE_GS1 52
#define NOTE_A1  55
#define NOTE_AS1 58
#define NOTE_B1  62
#define NOTE_C2  65
#define NOTE_CS2 69
#define NOTE_D2  73
#define NOTE_DS2 78
#define NOTE_E2  82
#define NOTE_F2  87
#define NOTE_FS2 93
#define NOTE_G2  98
#define NOTE_GS2 104
#define NOTE_A2  110
#define NOTE_AS2 117
#define NOTE_B2  123
#define NOTE_C3  131
#define NOTE_CS3 139
#define NOTE_D3  147
#define NOTE_DS3 156
#define NOTE_E3  165
#define NOTE_F3  175
#define NOTE_FS3 185
#define NOTE_G3  196
#define NOTE_GS3 208
#define NOTE_A3  220
#define NOTE_AS3 233
#define NOTE_B3  247
#define NOTE_C4  262
#define NOTE_CS4 277
#define NOTE_D4  294
#define NOTE_DS4 311
#define NOTE_E4  330
#define NOTE_F4  349
#define NOTE_FS4 370
#define NOTE_G4  392
#define NOTE_GS4 415
#define NOTE_A4  440
#define NOTE_AS4 466
#define NOTE_B4  494
#define NOTE_C5  523
#define NOTE_CS5 554
#define NOTE_D5  587
#define NOTE_DS5 622
#define NOTE_E5  659
#define NOTE_F5  698
#define NOTE_FS5 740
#define NOTE_G5  784
#define NOTE_GS5 831
#define NOTE_A5  880
#define NOTE_AS5 932
#define NOTE_B5  988
#define NOTE_C6  1047
#define NOTE_CS6 1109
#define NOTE_D6  1175
#define NOTE_DS6 1245
#define NOTE_E6  1319
#define NOTE_F6  1397
#define NOTE_FS6 1480
#define NOTE_G6  1568
#define NOTE_GS6 1661
#define NOTE_A6  1760
#define NOTE_AS6 1865
#define NOTE_B6  1976
#define NOTE_C7  2093
#define NOTE_CS7 2217
#define NOTE_D7  2349
#define NOTE_DS7 2489
#define NOTE_E7  2637
#define NOTE_F7  2794
#define NOTE_FS7 2960
#define NOTE_G7  3136
#define NOTE_GS7 3322
#define NOTE_A7  3520
#define NOTE_AS7 3729
#define NOTE_B7  3951
#define NOTE_C8  4186
#define NOTE_CS8 4435
#define NOTE_D8  4699
#define NOTE_DS8 4978
#define REST      0



//Incluimos la librería para controlar los neopixeles.
#include <Adafruit_NeoPixel.h>
#ifdef __AVR__
 #include <avr/power.h> // Required for 16 MHz Adafruit Trinket
#endif

//Definimos cantidad de neopixeles y pin.
#define PIN        11 
#define NUMPIXELS 16 
Adafruit_NeoPixel pixels(NUMPIXELS, PIN, NEO_GRB + NEO_KHZ800);


//Incluimos la librería para controlar la lcd y definimos pines.
#include <LiquidCrystal.h>
const int rs = 12, en = 13, d4 = 5, d5 = 4, d6 = 3, d7 = 2;
LiquidCrystal lcd(rs, en, d4, d5, d6, d7);


//Definimos pines para los botones y el buzzer
#define boton1 10
#define boton2 9
#define boton3 6
#define buzzer 8

//Creamos variables numéricas para controlar las canciones.
int cont2 = 0;
int cont = 1;

//definios caracteres de flechas pra mostrar en la lcd
byte flechai[8] = { B00010, B00110, B01110, B11111, B11111, B01110, B00110, B00010 };
byte flechad[8] = { B01000, B01100, B01110, B11111, B11111, B01110, B01100, B01000 };



void setup() {
  pixels.begin();     //Inicializamos los neopixeles.
  lcd.begin(16, 2);   //Inicializamos la lcd.
  lcd.createChar (0, flechad);    //Creamos el caracter de flecha derecha
  lcd.createChar (1, flechai);    //Creamos el caracter de flecha izquierda

  
}


//Programa que se ejecuta infinitamente
void loop() {
  rola();     //Utilizamos la función rola
  
  if (cont == 1) {    //Si el contador1 es igual a 1 reproducimos la canción 1
    cancion1();
    }
  if (cont == 2) {    //Si el contador1 es igual a 2 reproducimos la canción 2
    cancion2();
    }
  if (cont == 3) {    //Si el contador1 es igual a 3 reproducimos la canción 3
    cancion3();
    }
  delay(250);         //Esperamos 250 milisegundos antes de empezar de nuevo

  

//Función play_stop
int play_stop(){
  int est = digitalRead(boton2);   //Leemos el estado digital del boton 2

  if (est == HIGH){            //Si es alto canbiamos el valor del contador 2
    if (cont2 == 1) {         // cuando sea 1 pasará a ser 0 y viceversa.
      cont2 = 0;
      }
    else {
      cont2 = 1;
      }
    }
  }


//Función rola  
int rola(){
  int est1 = digitalRead(boton3);   //Leemos el estado digital del botón 3(avanzar a la derecha)
  int est2 = digitalRead(boton1);   //Leemos el estado digital del botón1 (avanzar a la izquierda)

  if (est1 == HIGH){        //Si el botón3 es presionado
    if (cont == 3){         //se suma uno al contador1 pero si este es 3 se cambia el valor a 1
      cont = 1;
      }
    else {
      cont ++;
      }
    }

  if (est2 == HIGH){        //Si el botón1 es presionado
    if (cont == 1){         //se resta uno al contador1 pero si este es 1 se cambia el valor a 3
      cont = 3;
      }
    else {
      cont --;
      }
    }
}


//Función canción 1
void cancion1() {
  //Programar color rojo en los neopixeles
  for(int i=0; i<NUMPIXELS; i++) { 
        pixels.setPixelColor(i, pixels.Color(35,1,1));
      }
      pixels.show();

   //Mostrar el nombre de la canción, el número y las flechas
   lcd.clear();
   lcd.setCursor(0,0);
   lcd.write("Sweet Child o M");
   lcd.setCursor(0,1);
   lcd.write(byte(1));
   lcd.setCursor(7,1);
   lcd.write("#1");
   lcd.setCursor(15,1);
   lcd.setCursor(15,1);
   lcd.write(byte(0));

   //Definir el tempo de la canción (rapidez con la que se reproduce).
   int tempo = 1000;
   
  //En una variable de lista numérica guardar las notas y el tiempo de reproducción de cada nota.
    int melodia[] = {
      NOTE_CS4,1, NOTE_CS5,1, NOTE_GS4,1, NOTE_FS4,1, NOTE_FS5,1.2, NOTE_GS4,1, NOTE_F5,1, NOTE_GS4, 1, 
      NOTE_CS4,1, NOTE_CS5,1, NOTE_GS4,1, NOTE_FS4,1, NOTE_FS5,1.2, NOTE_GS4,1, NOTE_F5,1, NOTE_GS4, 1,
      NOTE_DS4,1, NOTE_CS5,1, NOTE_GS4,1, NOTE_FS4,1, NOTE_FS5,1.2, NOTE_GS4,1, NOTE_F5,1, NOTE_GS4, 1, 
      NOTE_DS4,1, NOTE_CS5,1, NOTE_GS4,1, NOTE_FS4,1, NOTE_FS5,1.2, NOTE_GS4,1, NOTE_F5,1, NOTE_GS4, 1,
      NOTE_FS4,1, NOTE_CS5,1, NOTE_GS4,1, NOTE_FS4,1, NOTE_FS5,1.2, NOTE_GS4,1, NOTE_F5,1, NOTE_GS4, 1, 
      NOTE_FS4,1, NOTE_CS5,1, NOTE_GS4,1, NOTE_FS4,1, NOTE_FS5,1.2, NOTE_GS4,1, NOTE_F5,1, NOTE_GS4, 1,
      NOTE_DS5,1, NOTE_GS4,1, NOTE_CS5,1, NOTE_GS4,1, NOTE_DS5,1.2, NOTE_GS4,1, NOTE_F5,1, NOTE_GS4,1,
      NOTE_FS5,1, NOTE_GS4,1, NOTE_F5,1, NOTE_GS4,1, NOTE_DS5,1, NOTE_GS4,1, NOTE_CS5,1
      };
    
  
    int notes = sizeof(melodia) / sizeof(melodia[0]) / 2;
  
    //Se calcula la duracion en segundos
    int notacom = (60000 * 4) / tempo;
    int divisor = 0, duracion = 0;

    //Se esperan 300 milisegundos antes de empezar
    delay(300);

    //Se utiliza la función rola para saber si se cambió la canción.
    rola(); 

    //Se reproduce la canción en un ciclo
    for (int nota = 0; nota < notes * 2; nota = nota + 2) {
      play_stop();        //Ejecuta la función play_stop
      if (cont != 1) {    //si el contador 1 es diferente a 1 termina el ciclo
        break;
        }
      if (cont2 == 0){    //Si el contador2 es igual a 0 termina el ciclo
        break;
        }

        
      // Se calculan las draciones
      divisor = [nota + 1];
      if (divisor > 0) {
        // Normales tiempos positivos
        duracion = (notacom) / divisor;
      } else if (divisor < 0) {
        // Sostenidas tienen tiempos negativos
        duracion = (notacom) / abs(divisor);
        duracion *= 1.5; // increases the duration in half for dotted notes
      }
  
      // Se reprodce por el 90% del tiempo, el restante es de pausa
      tone(buzzer, melody[nota], duracion*0.9);
      // Se espera el tiempo de la nota.
      delay(duracion);
      //Se detiene la reproducción antes de la siguiente nota
      noTone(buzzer);  
    }
    
    cont2 = 0;    //El contador2 se hace 0 para detener la reproducción
    delay(300);   //Se esperan 300 milisegundos.
    
}


//Función canción 2
void cancion2() {
  //Programa el color verde en los neopixeles
  for(int i=0; i<NUMPIXELS; i++) { 
        pixels.setPixelColor(i, pixels.Color(1,35,1));
      }
  pixels.show();

  //Mostrar el nombre de la canción, el número y las flechas
  lcd.clear();
  lcd.setCursor(0,0);
  lcd.print("Godfather theme");
  lcd.setCursor(0,1);
  lcd.write(byte(1));
  lcd.setCursor(7,1);
  lcd.print("#2");
  lcd.setCursor(15,1);
  lcd.write(byte(0));
  


  /***************************************************************************************
*    título: arduino song / Godfather theme song
*    Autor: Robson Couto
*    Fecha: 4 de mayo de 2019
*    Fuente: https://github.com/robsoncouto/arduino-songs/tree/master/thegodfather
*
***************************************************************************************/
int tempo = 80;
  int melody[] = {
  NOTE_E4, 8, NOTE_A4, 8, NOTE_C5, 8, //1
  NOTE_B4, 8, NOTE_A4, 8, NOTE_C5, 8, NOTE_A4, 8, NOTE_B4, 8, NOTE_A4, 8, NOTE_F4, 8, NOTE_G4, 8,
  NOTE_E4, 2, NOTE_E4, 8, NOTE_A4, 8, NOTE_C5, 8,
  NOTE_B4, 8, NOTE_A4, 8, NOTE_C5, 8, NOTE_A4, 8, NOTE_C5, 8, NOTE_A4, 8, NOTE_E4, 8, NOTE_DS4, 8,
  NOTE_D4, 2, NOTE_D4, 8, NOTE_F4, 8, NOTE_GS4, 8, //5
  NOTE_B4, 2, NOTE_D4, 8, NOTE_F4, 8, NOTE_GS4, 8,
  NOTE_A4, 2, NOTE_C4, 8, NOTE_C4, 8, NOTE_G4, 8,
  NOTE_F4, 8, NOTE_E4, 8, NOTE_G4, 8, NOTE_F4, 8, NOTE_F4, 8, NOTE_E4, 8, NOTE_E4, 8, NOTE_GS4, 8,

  NOTE_A4, 2, REST,8, NOTE_A4, 8, NOTE_A4, 8, NOTE_GS4, 8, //9
  NOTE_G4, 2, NOTE_B4, 8, NOTE_A4, 8, NOTE_F4, 8, 
  NOTE_E4, 2, NOTE_E4, 8, NOTE_G4, 8, NOTE_E4, 8,
  NOTE_D4, 2, NOTE_D4, 8, NOTE_D4, 8, NOTE_F4, 8, NOTE_DS4, 8
  };
  int notes = sizeof(melody) / sizeof(melody[0]) / 2;

  // this calculates the duration of a whole note in ms (60s/tempo)*4 beats
  int wholenote = (60000 * 4) / tempo;
  
  int divider = 0, noteDuration = 0;
  delay(300);
    rola();
  for (int thisNote = 0; thisNote < notes * 2; thisNote = thisNote + 2) {
    play_stop();
      if (cont != 2) {
        break;
        }
    if (cont2 == 0){
      break;
      }
    // calculates the duration of each note
    divider = melody[thisNote + 1];
    if (divider > 0) {
      // regular note, just proceed
      noteDuration = (wholenote) / divider;
    } else if (divider < 0) {
      // dotted notes are represented with negative durations!!
      noteDuration = (wholenote) / abs(divider);
      noteDuration *= 1.5; // increases the duration in half for dotted notes
    }
    tone(buzzer, melody[thisNote], noteDuration*0.9);
    delay(noteDuration);
    noTone(buzzer);
  }
  
  cont2 = 0;     //El contador2 lo hacemos 0 para qe se detenga la reproducción
  delay(300);    //Esperamos 300 milisegundos

}

//función canción 3
void cancion3(){
  //Programar el color azul en los neopixeles.
  for(int i=0; i<NUMPIXELS; i++) { 
        pixels.setPixelColor(i, pixels.Color(1,1,35));
      }
      pixels.show();

  //Mostrar el nombre de la canción, el número y las flechas
  lcd.clear();
  lcd.setCursor(3,0);
  lcd.print("Take on me");
  lcd.setCursor(0,1);
  lcd.write(byte(1));
  lcd.setCursor(7,1);
  lcd.print("#3");
  lcd.setCursor(15,1);
  lcd.write(byte(0));
  


  /***************************************************************************************
*    título: arduino song / take on me
*    Autor: Robson Couto
*    Fecha: 21 de febrero de 2019
*    Fuente: https://github.com/robsoncouto/arduino-songs/blob/master/takeonme/takeonme.ino
*
***************************************************************************************/
int tempo = 140;
  int melody[] = {
  NOTE_FS5,8, NOTE_FS5,8,NOTE_D5,8, NOTE_B4,8, REST,8, NOTE_B4,8, REST,8, NOTE_E5,8, 
  REST,8, NOTE_E5,8, REST,8, NOTE_E5,8, NOTE_GS5,8, NOTE_GS5,8, NOTE_A5,8, NOTE_B5,8,
  NOTE_A5,8, NOTE_A5,8, NOTE_A5,8, NOTE_E5,8, REST,8, NOTE_D5,8, REST,8, NOTE_FS5,8, 
  REST,8, NOTE_FS5,8, REST,8, NOTE_FS5,8, NOTE_E5,8, NOTE_E5,8, NOTE_FS5,8, NOTE_E5,8,
  NOTE_FS5,8, NOTE_FS5,8,NOTE_D5,8, NOTE_B4,8, REST,8, NOTE_B4,8, REST,8, NOTE_E5,8, 
  
  REST,8, NOTE_E5,8, REST,8, NOTE_E5,8, NOTE_GS5,8, NOTE_GS5,8, NOTE_A5,8, NOTE_B5,8,
  NOTE_A5,8, NOTE_A5,8, NOTE_A5,8, NOTE_E5,8, REST,8, NOTE_D5,8, REST,8, NOTE_FS5,8, 
  REST,8, NOTE_FS5,8, REST,8, NOTE_FS5,8, NOTE_E5,8, NOTE_E5,8, NOTE_FS5,8, NOTE_E5,8,
  NOTE_FS5,8, NOTE_FS5,8,NOTE_D5,8, NOTE_B4,8, REST,8, NOTE_B4,8, REST,8, NOTE_E5,8, 
  REST,8, NOTE_E5,8, REST,8, NOTE_E5,8, NOTE_GS5,8, NOTE_GS5,8, NOTE_A5,8, NOTE_B5,8,
  
  NOTE_A5,8, NOTE_A5,8, NOTE_A5,8, NOTE_E5,8, REST,8, NOTE_D5,8, REST,8, NOTE_FS5,8, 
  REST,8, NOTE_FS5,8, REST,8, NOTE_FS5,8, NOTE_E5,8, NOTE_E5,8, NOTE_FS5,8, NOTE_E5,8,
  
};

  int notes = sizeof(melody) / sizeof(melody[0]) / 2;

  // this calculates the duration of a whole note in ms (60s/tempo)*4 beats
  int wholenote = (60000 * 4) / tempo;
  int divider = 0, noteDuration = 0;
  delay(300);
    rola();
  for (int thisNote = 0; thisNote < notes * 2; thisNote = thisNote + 2) {
    play_stop();
      if (cont != 3) {
        break;
        }
    if (cont2 == 0){
      break;
      }
    // calculates the duration of each note
    divider = melody[thisNote + 1];
    if (divider > 0) {
      // regular note, just proceed
      noteDuration = (wholenote) / divider;
    } else if (divider < 0) {
      // dotted notes are represented with negative durations!!
      noteDuration = (wholenote) / abs(divider);
      noteDuration *= 1.5; // increases the duration in half for dotted notes
    }

    // we only play the note for 90% of the duration, leaving 10% as a pause
    tone(buzzer, melody[thisNote], noteDuration*0.9);

    // Wait for the specief duration before playing the next note.
    delay(noteDuration);
    
    // stop the waveform generation before the next note.
    noTone(buzzer);
  }
  cont2 = 0;   //El contador2 sehace 0 para detener la reproducción
  delay(300);  //Espera de 300 milisegundos.
  

}
